(function(window, document, $, undefined){

  var hpadmin = {};

  hpadmin.init = function() {
    $('#hwp_show_on_tags').suggest( window.ajaxurl + "?action=ajax-tag-search&tax=post_tag", {multiple:true, multipleSep: ","});
    $('#hwp_show_on_cats').suggest( window.ajaxurl + "?action=ajax-tag-search&tax=category", {multiple:true, multipleSep: ","});
    $('#hwp_show_on_types').suggest( window.ajaxurl + "?action=hwp_ajax_type_search", {multiple:true, multipleSep: ","});

    $('#hwp_show_exclude_pages').suggest( window.ajaxurl + "?action=hwp_ajax_page_search", {multiple:true, multipleSep: ","});

    $('body')
    	.on('change', 'select[name=mc_list_id]', hpadmin.resetGroups )
    	.on('change', 'select[name=mc_groups]', hpadmin.getMcInterests )

    if( $('select[name=mc_list_id]').val() ) {
    	hpadmin.getMcGroups(true)
    }
    
  }

  hpadmin.resetGroups = function() {
  	// reset
  	$('#mc_interest_checkboxes').html('');
  	$('#mailchimp-interests').hide();
  	$('select[name=mc_groups]').html('<option>None</option>').val('None');
  	$('#mailchimp-groups').hide();

  	hpadmin.getMcGroups();
  }

  hpadmin.getMcGroups = function( initialLoad ) {

  	hpadmin.showSpinner();

    var myNonce = $('#hollerbox_meta_box_nonce').val();
    var listId = $('select[name=mc_list_id]').val();

    if( !listId || listId === ''  )
      return;

    $.ajax({
      method: "GET",
      url: window.ajaxurl,
      data: { nonce: myNonce, action: 'hwp_get_mc_groups', list_id: listId }
      })
      .done(function(msg) {

        hpadmin.populateGroups(msg, initialLoad )

        hpadmin.hideSpinner()

      })
      .fail(function(err) {
        console.log(err);
        hpadmin.hideSpinner()
      });

  }

  hpadmin.populateGroups = function( data, initialLoad ) {

  	var data = JSON.parse( data.data );
  	var cats = data.categories;

  	var menu = $('select[name="mc_groups"]');

  	var option = '';
	for (var i=0;i<cats.length;i++){

		option += '<option value="'+ cats[i].id + '">' + cats[i].title + '</option>';
	}

	menu.append(option);

	$('#mailchimp-groups').fadeIn();

	if( initialLoad )
		hpadmin.selectCurrentGroups()

	hpadmin.getMcInterests( initialLoad )

  }

  hpadmin.getMcInterests = function( initialLoad ) {

  	hpadmin.showSpinner()

    var myNonce = $('#hollerbox_meta_box_nonce').val();
    var listId = $('select[name=mc_list_id]').val();
    var groupId = $('select[name=mc_groups]').val();

    if( !groupId || groupId === '' || groupId === 'None' )
      return;

    $.ajax({
      method: "GET",
      url: window.ajaxurl,
      data: { nonce: myNonce, action: 'hwp_get_mc_group_interests', list_id: listId, group_id: groupId }
      })
      .done(function(msg) {

        hpadmin.populateInterests( msg, initialLoad )

        hpadmin.hideSpinner()

      })
      .fail(function(err) {
        console.log(err);
        hpadmin.hideSpinner()
      });

  }

  hpadmin.populateInterests = function( data, initialLoad ) {

  	var data = JSON.parse( data.data );
  	var cats = data.interests;

  	var menu = $('#mc_interest_checkboxes');

  	var checkboxes = '';
	for (var i=0;i<cats.length;i++){
	   checkboxes += '<p><input type="checkbox" name="mc_interests['+ cats[i].id + ']" value="true">' + cats[i].name + '</input></p>';
	}

	menu.append(checkboxes);

  	$('#mailchimp-interests').fadeIn();

  	if( initialLoad )
		hpadmin.selectCurrentInterests()

  }

  // only runs first page load to select current options
  hpadmin.selectCurrentGroups = function() {

  	var groupId = window.hwpAdmin.current_mc_group;

  	if( groupId ) {
  		$('select[name="mc_groups"] option[value=' + groupId + ']').prop('selected', true);
  	}

  }

  // only runs first page load to select current options
  hpadmin.selectCurrentInterests = function() {

  	var ids = window.hwpAdmin.current_mc_interests;

  	for (var key in ids) {
  		$('#mc_interest_checkboxes input[name="mc_interests[' + key + ']"]').prop('checked', true);
  	}

  }

  hpadmin.showSpinner = function() {

  	$('img.hwp-loading').show();

  }

  hpadmin.hideSpinner = function() {

  	$('img.hwp-loading').hide();
  	
  }

  hpadmin.init();

  window.hollerProAdmin = hpadmin;

})(window, document, jQuery);